unit lutils;

(***************************************)
(*  LENIN INC                          *)
(*  Online:  http://lenininc.narod.ru  *)
(*  E-Mail:  lenin@zeos.net            *)
(*  Free for non commercial use.       *)
(***************************************)

interface

uses
  Windows;

const
  faReadOnly  = $00000001;
  faHidden    = $00000002;
  faSysFile   = $00000004;
  faVolumeID  = $00000008;
  faDirectory = $00000010;
  faArchive   = $00000020;
  faAnyFile   = $0000003F;

type
  WordRec = packed record
    Lo, Hi: Byte;
  end;

type
 TFileName = string;

type
  LongRec = packed record
    Lo, Hi: Word;
  end;

type
  TSearchRec = record
    Time: Integer;
    Size: Integer;
    Attr: Integer;
    Name: TFileName;
    ExcludeAttr: Integer;
    FindHandle: THandle;
    FindData: TWin32FindData;
  end;

{}
//  ?
function FileExists( const FileName : String ) : Boolean;
//  
function ExtractFileExt(const Path : String) : String;
//  
function ChangeFileExt(FileName: String; const Extension: string): string;
//  
function ExtractFileName(const Path : String) : String;
// 
function ExtractFilePath(const Path : String) : String;
//    
function ExtractFileNameWOext(const Path : String) : String;
//       PathName.
//    aaa.txt     aaa1.txt, aaa2.txt...
function GetUniqueFilename(PathName: string) : String;
//  
function GetFileSize(FileName : string): Integer;
//     .
//TimeOut -     .    
//        true  ProcID
//  nil.    TimeOut = INFINITE   
//    (  -   ).
//AppPath, CmdLine, DfltDirectory -  ,    
//   
//Show -  SW_SHOW, SW_HIDE    SW_XXX 
//ProcID -   
//ExecuteWait('Command.com', '', 'C:\', SW_SHOW, INFINITE, nil);
function ExecuteWait(const AppPath, CmdLine, DfltDirectory: String;
                     Show: DWORD; TimeOut: DWORD; ProcID: PDWORD): Boolean;
//   
function RunControlPanelApplet(CplFile : string): integer;
// .INF 
{ InfFile - .INF 
  Section -  ,    . : DefaultInstall
  Mode -   ( - 132):
  0  128 -   .
  1  129 -      .
  2  130 -   ,    .
  3  131 - ,     .  
              ,     .
  4  132 - ,     .  
              ,    ,    . }
function IinstallInfFile(InfFile, Section, Mode: String): integer;
//  
function CreateUrl(Url, Path, Name: string): Boolean;
//  
function FileSetAttr(const FileName: string; Attr: Integer): Integer;
//  
function FileGetAttr(const FileName: string): Integer;
///    OCX, DLL
function RegisterServer(const aDllFileName: string; aRegister: Boolean): Boolean;

{}
//   ( )
function GetDirectorySize(ADirectory: string): Integer;
function _GetDirectorySize(ADirectory: string;var MaxSize:integer): boolean;
//     ( )
//: {$I-} DoDelTree('C:\WINDOWS\TEMP\'); {$I+}
procedure DoDelTree(TheDir : String);
//  ?
function DirectoryExists(const Name: string): Boolean;
//  ?
function DirectoryEmpty(const ADirPath :string) :boolean;
// 
function CreateDir(const Dir: string): Boolean;
//    
function GetStartDir: String;
//     
function GetShortFileName(Const FileName : String): String;
//  TEMP
function TempDir: string;
//  Windows
function WindowsDir: String;
//  System
function SystemDir: String;
//  Program Files
function ProgramFilesDir: string;
//  
function RootDir: String;
//     
function GetLastDir(str: String): String;
//  
{   ShellPath :
Desktop              - C:\WINDOWS\ 
Templates            - C:\WINDOWS\ShellNew
AppData              - C:\WINDOWS\Application Data
Start Menu           - C:\WINDOWS\ 
Programs             - C:\WINDOWS\ \
Startup              - C:\WINDOWS\ \\
Fonts                - C:\WINDOWS\Fonts
SendTo               - C:\WINDOWS\SendTo
Recent               - C:\WINDOWS\Recent
Favorites            - C:\WINDOWS\
Cache                - C:\WINDOWS\Temporary Internet Files
Cookies              - C:\WINDOWS\Cookies
History              - C:\WINDOWS\History
NetHood              - C:\WINDOWS\NetHood
Personal             - C:\ 
PrintHood            - C:\WINDOWS\PrintHood
Local AppData        - C:\WINDOWS\Local Settings\Application Data
My Pictures          - C:\ \ 
Administrative Tools - C:\WINDOWS\ \\  }
function ShellDir(ShellPath: String): string;

{ ...}
type
 TOSVersion = (osUnknown, osUnknown9x, osUnknownNT, osWin95,
               osWin98, osWin98SE, osWinME, osWinNT, osWin2000, osXP);
//  
function GetOSVersion : TOSVersion;
// , 
function ProcessMessages : Boolean;
//Shutdown/reboot/logoff Windows 9x/NT/Me/2000/XP
function MyExitWindows(RebootParam: word): Boolean;

{}
// Integer  String
function InStr(I: Integer): string;
// String  Integer
function InInt(S: String): Integer;
//  "" 
procedure SysDelay(aMs: cardinal);
// ,     SysUtils.pas
function Format(fmt: string; params: array of const): string;
function StrPas(Str: PChar): string;
function AnsiStrLIComp(S1, S2: PChar; MaxLen: Cardinal): Integer;
function AnsiCompareText(const S1, S2: string): Integer;
function FindMatchingFile(var F: TSearchRec): Integer;
procedure FindClose(var F: TSearchRec);
function FindFirst(const Path: string; Attr: Integer; var F: TSearchRec): Integer;
function FindNext(var F: TSearchRec): Integer;
function StrLen(const Str: PChar): Cardinal; assembler;
function StrRScan(const Str: PChar; Chr: Char): PChar; assembler;
function DelimiterLast(const Str, Delimiters: String): Integer;
function StrLCopy(Dest, Source: PChar; MaxLen: Cardinal): PChar; assembler;
function StrPCopy(Dest: PChar; const Source: string): PChar;
function UpperCase(const S: string): string;

implementation

function InStr(I: Integer): string;
var
 S: string;
begin
 Str(I, S); InStr:= S;
end;

function InInt(S: String): Integer;
var
 I, Code: Integer;
begin
 Val(S, I, Code); InInt := I;
end;

function Format(fmt: string; params: array of const): string;
var
  pdw1, pdw2: PDWORD;
  i: integer;
  pc: PCHAR;
begin
  pdw1 := nil;
  if length(fmt) > 0 then
   GetMem(pdw1, sizeof(Pointer));
  pdw2 := pdw1;
  for i := 0 to high(params) do begin
    pdw2^ := DWORD(PDWORD(@params[i])^);
    inc(pdw2);
  end;
  GetMem(pc, 1024 - 1);
  try
    SetString(Result, pc, wvsprintf(pc, PCHAR(fmt), PCHAR(pdw1)));
  except
    Result := '';
  end;
  if (pdw1 <> nil) then FreeMem(pdw1);
  if (pc <> nil) then FreeMem(pc);
end;

function StrPas(Str: PChar): string;
begin
  Result := Str;
end;

function AnsiStrLIComp(S1, S2: PChar; MaxLen: Cardinal): Integer;
begin
  Result := CompareString(LOCALE_USER_DEFAULT, NORM_IGNORECASE,
    S1, MaxLen, S2, MaxLen) - 2;
end;

function AnsiCompareText(const S1, S2: string): Integer;
begin
  Result := CompareString(LOCALE_USER_DEFAULT, NORM_IGNORECASE, PChar(S1),
    Length(S1), PChar(S2), Length(S2)) - 2;
end;

function FindMatchingFile(var F: TSearchRec): Integer;
var
  LocalFileTime: TFileTime;
begin
  with F do
  begin
    while FindData.dwFileAttributes and ExcludeAttr <> 0 do
      if not FindNextFile(FindHandle, FindData) then
      begin
        Result := GetLastError;
        Exit;
      end;
    FileTimeToLocalFileTime(FindData.ftLastWriteTime, LocalFileTime);
    FileTimeToDosDateTime(LocalFileTime, LongRec(Time).Hi,
      LongRec(Time).Lo);
    Size := FindData.nFileSizeLow;
    Attr := FindData.dwFileAttributes;
    Name := FindData.cFileName;
  end;
  Result := 0;
end;

procedure FindClose(var F: TSearchRec);
begin
  if F.FindHandle <> INVALID_HANDLE_VALUE then
    Windows.FindClose(F.FindHandle);
end;

function FindFirst(const Path: string; Attr: Integer;
  var F: TSearchRec): Integer;
const
  faSpecial = faHidden or faSysFile or faVolumeID or faDirectory;
begin
  F.ExcludeAttr := not Attr and faSpecial;
  F.FindHandle := FindFirstFile(PChar(Path), F.FindData);
  if F.FindHandle <> INVALID_HANDLE_VALUE then
  begin
    Result := FindMatchingFile(F);
    if Result <> 0 then FindClose(F);
  end else
    Result := GetLastError;
end;

function FindNext(var F: TSearchRec): Integer;
begin
  if FindNextFile(F.FindHandle, F.FindData) then
    Result := FindMatchingFile(F) else
    Result := GetLastError;
end;

function DirectoryEmpty(const ADirPath :string) :boolean;
var
 F :TSearchRec;
begin
 Result := (FindFirst(ADirPath+'\*.*',faAnyFile,F) = 0) and
           (FindNext(F) = 0) and (FindNext(F) <> 0);
 FindClose(F);
end;

//      
function ProcessMessages : Boolean;
const
 WM_QUIT  = $0012;
var
 Msg : TMsg;
begin
 Result := False;
 while PeekMessage(Msg, 0, 0, 0, PM_REMOVE) do begin
  if Msg.Message = WM_QUIT then
  begin Exit end else begin
   TranslateMessage(Msg);
   DispatchMessage(Msg);
  end;
 end; Result := True;
end;

function DirectoryExists(const Name: string): Boolean;
var
  Code: Integer;
begin
  Code := GetFileAttributes(PChar(Name));
  Result := (Code <> -1) and (FILE_ATTRIBUTE_DIRECTORY and Code <> 0);
end;

function FileExists( const FileName : String ) : Boolean;
var
  Code: Integer;
begin
  Code := GetFileAttributes(PChar(FileName));
  Result := (Code <> -1) and (FILE_ATTRIBUTE_DIRECTORY and Code = 0);
end;

function CreateDir(const Dir: string): Boolean;
begin
   Result := Windows.CreateDirectory(PChar(Dir), nil);
end;

function StrLen(const Str: PChar): Cardinal; assembler;
asm
        XCHG    EAX, EDI
        XCHG    EDX, EAX
        OR      ECX, -1
        XOR     EAX, EAX
        CMP     EAX, EDI
        JE      @@exit0
        REPNE   SCASB
        DEC     EAX
        DEC     EAX
        SUB     EAX,ECX
@@exit0:
        MOV     EDI,EDX
end;

function StrRScan(const Str: PChar; Chr: Char): PChar; assembler;
asm
        PUSH    EDI
        MOV     EDI,Str
        MOV     ECX,0FFFFFFFFH
        XOR     AL,AL
        REPNE   SCASB
        NOT     ECX
        STD
        DEC     EDI
        MOV     AL,Chr
        REPNE   SCASB
        MOV     EAX,0
        JNE     @@1
        MOV     EAX,EDI
        INC     EAX
@@1:    CLD
        POP     EDI
end;

function GoDelimiterLast(Str: PChar; Delimiters: PChar): PChar;
var
    P, F : PChar;
begin
  P := Str;
  Result := P + StrLen(Str);
  while Delimiters^ <> #0 do
  begin
    F := StrRScan(P, Delimiters^);
    if F <> nil then
    if (Result^ = #0) or (Integer(F) > Integer(Result)) then
       Result := F;
    Inc(Delimiters);
  end;
end;

function DelimiterLast(const Str, Delimiters: String): Integer;
var
 PStr: PChar;
begin
 PStr := PChar(Str);
 Result := Integer(GoDelimiterLast(PStr, PChar(Delimiters))) - Integer(PStr);
end;

function ExtractFileExt(const Path : String) : String;
var
 P: PChar;
begin
 P := GoDelimiterLast(PChar(Path), '.');
 Result := P;
end;

procedure DeleteTail(var S : String; Len : Integer);
var
 L : Integer;
begin
  L := Length(S);
  if Len > L then
     Len := L;
  Delete(S, L - Len + 1, Len);
end;

function ChangeFileExt(FileName: String; const Extension: string): string;
var
   FileExt: String;
begin
   FileExt := ExtractFileExt(FileName);
   DeleteTail(FileName, Length(FileExt));
   Result := FileName+ Extension;
end;

function ExtractFileName(const Path : String) : String;
var P: PChar;
begin
  P := GoDelimiterLast(PChar(Path), ':\');
  if P^ = #0 then
    Result := Path
  else
    Result := P + 1;
end;

function ExtractFilePath(const Path : String) : String;
var
 P, P0: PChar;
begin
 P0 := PChar(Path);
 P := GoDelimiterLast(P0, ':\');
  if P^ = #0 then
   Result := ''
  else
   Result := Copy(Path, 1, P - P0 + 1);
end;

function ExtractFileNameWOext(const Path : String) : String;
begin
 Result := ExtractFileName(Path);
 Result := Copy(Result, 1, Length(Result) - Length(ExtractFileExt(Result)));
end;

function CopyEnd(const S : String; Idx : Integer) : String;
var
 L : Integer;
begin
 L := Length(S);
  if Idx < 1 then Idx := 1;
  if Idx > L then
   Result := ''
  else
   Result := Copy(S, Idx, L - Idx + 1);
end;

function GetUniqueFilename(PathName: string) : String;
var Path, Nam, Ext : String;
    I, J, K : Integer;
begin
  Result := PathName;
  Path := ExtractFilePath(PathName);
  if not DirectoryExists(Path) then Exit;
  Nam := ExtractFileNameWOext(PathName);
  if Nam = '' then
  begin
    if Path[ Length(Path) ] = '\' then
       Path := Copy(Path, 1, Length(Path) - 1);
    PathName := Path;
    Result := Path;
  end;
  Nam := ExtractFileNameWOext(PathName);
  Ext := ExtractFileExt(PathName);
  I := Length(Nam);
  for J := I downto 1 do
  if not (Nam[ J ] in [ '0'..'9' ]) then
  begin
    I := J;
    break;
  end;
  K := InInt(CopyEnd(Nam, I + 1));
  while FileExists(Result) do
  begin
    Inc(K);
    Result := Path + Copy(Nam, 1, I) + InStr(K) + Ext;
  end;
end;

function StrLCopy(Dest, Source: PChar; MaxLen: Cardinal): PChar; assembler;
asm
        PUSH    EDI
        PUSH    ESI
        PUSH    EBX
        MOV     ESI,EAX
        MOV     EDI,EDX
        MOV     EBX,ECX
        XOR     AL,AL
        TEST    ECX,ECX
        JZ      @@1
        REPNE   SCASB
        JNE     @@1
        INC     ECX
@@1:    SUB     EBX,ECX
        MOV     EDI,ESI
        MOV     ESI,EDX
        MOV     EDX,EDI
        MOV     ECX,EBX
        SHR     ECX,2
        REP     MOVSD
        MOV     ECX,EBX
        AND     ECX,3
        REP     MOVSB
        STOSB
        MOV     EAX,EDX
        POP     EBX
        POP     ESI
        POP     EDI
end;

function StrPCopy(Dest: PChar; const Source: string): PChar;
begin
 Result := StrLCopy(Dest, PChar(Source), 255);
end;

function ExecuteWait(const AppPath, CmdLine, DfltDirectory: String;
         Show: DWORD; TimeOut: DWORD; ProcID: PDWORD): Boolean;
var
 Flags: DWORD;
 Startup: TStartupInfo;
 ProcInf: TProcessInformation;
 DfltDir: PChar;
 App: String;
begin
 Result := FALSE;
 Flags := CREATE_NEW_CONSOLE;
  if Show = SW_HIDE then Flags := Flags or CREATE_NO_WINDOW;
   FillChar(Startup, SizeOf(Startup), 0);
   Startup.cb := Sizeof(Startup);
   Startup.wShowWindow := Show;
   Startup.dwFlags := STARTF_USESHOWWINDOW;
  if ProcID <> nil then ProcID^ := 0;
   DfltDir := nil;
  if DfltDirectory <> '' then DfltDir := PChar(DfltDirectory);
  if ProcID <> nil then ProcID^ := 0;
   App := AppPath;
  if (pos(' ', App) > 0) and (pos('"', App) <= 0) then App := '"' + App + '"';
  if CreateProcess(nil, PChar(App + ' ' + CmdLine), nil,
   nil, FALSE, Flags, nil, DfltDir, Startup, ProcInf) then
    begin
     if WaitForSingleObject(ProcInf.hProcess, TimeOut) = WAIT_OBJECT_0 then
      begin
       CloseHandle(ProcInf.hProcess);
       Result := TRUE;
      end else begin
       if ProcID <> nil then ProcID^ := ProcInf.hProcess;
      end;
     CloseHandle(ProcInf.hThread);
    end;
end;

//     
function GetLastDir(str: String): String;
var
 i:integer;
begin
 for i := length(str) downto 1 do
  if str[i] = '\' then begin
   Result := Copy(str, i+1, Length(str) -i + 1);
   Break;
  end;
end;

function GetStartDir: String;
var
 Buffer:array[0..260] of Char;
 I : Integer;
begin
 I := GetModuleFileName(0, Buffer, Sizeof(Buffer));
  for I := I downto 0 do
   if Buffer[I] = '\' then
    begin
     Buffer[I + 1] := #0;
     break;
    end;
  Result := Buffer;
end;

//  TEMP
function TempDir: string;
var
 buffer: array[0..1023] of char;
begin
 SetString(Result, Buffer, GetTempPath(Sizeof(Buffer)-1,Buffer));
 if (Result <> '') and (Result[Length(Result)] <> '\') then Result := Result + '\';
end;

//  Windows
function WindowsDir: String;
var
 buffer: array[0..1023] of char;
begin
 SetString(Result, Buffer, GetWindowsDirectory(Buffer, Sizeof(Buffer)-1));
 if (Result <> '') and (Result[Length(Result)] <> '\') then Result := Result + '\';
end;

//  System
function SystemDir: String;
var
 buffer: array[0..1023] of char;
begin
 SetString(Result, Buffer, GetSystemDirectory(Buffer, Sizeof(Buffer)-1));
 if (Result <> '') and (Result[Length(Result)] <> '\') then Result := Result + '\';
end;

//  Program Files
function ProgramFilesDir: string;
var
 Handle: HKEY;
 DataType, DataSize: DWORD;
begin
if RegOpenKeyEx(HKEY_LOCAL_MACHINE, PChar('SOFTWARE\Microsoft\Windows\CurrentVersion'),
 0, KEY_QUERY_VALUE, Handle) = ERROR_SUCCESS then
  if RegQueryValueEx(Handle, PChar('ProgramFilesPath'), nil, @DataType, nil, @DataSize) = ERROR_SUCCESS then
   begin
    SetString(Result, nil, DataSize-1);
    RegQueryValueEx(Handle, PChar('ProgramFilesPath'), nil, @DataType, PByte(@Result[1]), @DataSize);
    //    - 
    if (Result <> '') and (Result[Length(Result)] <> '\') then Result := Result + '\';
   end else Result := '';
 RegCloseKey(Handle);
end;

//  
function RootDir: String;
var
 buffer: array[0..1023] of char;
begin
 SetString(Result, Buffer, GetWindowsDirectory(Buffer, Sizeof(Buffer)-1));
 if (Result <> '') and (Result[Length(Result)] <> '\') then Result := Copy(Result + '\', 1, 3);
end;

function ShellDir(ShellPath: String): string;
var
 Handle: HKEY;
 DataType, DataSize: DWORD;
begin
if RegOpenKeyEx(HKEY_CURRENT_USER, PChar('SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders'),
 0, KEY_QUERY_VALUE, Handle) = ERROR_SUCCESS then
  if RegQueryValueEx(Handle, PChar(ShellPath), nil, @DataType, nil, @DataSize) = ERROR_SUCCESS then
   begin
    SetString(Result, nil, DataSize-1);
    RegQueryValueEx(Handle, PChar(ShellPath), nil, @DataType, PByte(@Result[1]), @DataSize);
    //    - 
    if (Result <> '') and (Result[Length(Result)] <> '\') then Result := Result + '\';
   end else Result := '';
 RegCloseKey(Handle);
end;

//  
function GetOSVersion : TOSVersion;
var
 osVerInfo : TOSVersionInfo;
 majorVer, minorVer : Integer;
begin
 result := OsUnknown;
 osVerInfo.dwOSVersionInfoSize := SizeOf(TOSVersionInfo);
  if GetVersionEx(osVerInfo) then
   begin
    majorVer := osVerInfo.dwMajorVersion;
    minorVer := osVerInfo.dwMinorVersion;
    case osVerInfo.dwPlatformId of
      VER_PLATFORM_WIN32_NT :
        Case majorVer of
          4:result := OsWinNT;
          5: if minorVer=0 then result := OsWin2000
             else if minorVer=1 then
                    result := OsXP else result := osUnknownNT;
          else result := osUnknownNT;
        end; {Case majorVer of}
      VER_PLATFORM_WIN32_WINDOWS :
        case majorVer of
          4: Case minorVer of
               0:result := OsWin95;
               10: if osVerInfo.szCSDVersion[1] = 'A' then
                    result := OsWin98SE else result := OsWin98;
               90: result := OsWinME;
               else result := osUnknown9x;
             end;{Case minorVer of}
          else result := osUnknown9x;
        end;{case majorVer of}
      else result := OsUnknown;
    end;{case osVerInfo.dwPlatformId of}
  end;{if GetVersionEx(osVerInfo) then}
end;

//     
function GetShortFileName(Const FileName : String): String;
var
 aTmp: array[0..255] of char;
begin
 if GetShortPathName(PChar(FileName),aTmp,Sizeof(aTmp)-1)=0 then
  Result:= FileName else Result:=aTmp;
end;

function RunControlPanelApplet(CplFile : string): integer;
begin
 Result := WinExec(PChar('rundll32.exe shell32.dll,'+
  'Control_RunDLL ' + CplFile), SW_SHOWNORMAL);
end;

function IinstallInfFile(InfFile, Section, Mode: String): integer;
begin
 Result := WinExec(PChar('rundll.exe setupx.dll,InstallHinfSection '+
  Section + ' ' + Mode +' '+ InfFile), SW_SHOWNORMAL);
end;

//  
function GetFileSize(FileName : string): Integer;
var
 InfoFile : TSearchRec;
 AttrFile : Integer;
 ErrorReturn : Integer;
begin
 AttrFile := $0000003F;
 ErrorReturn := FindFirst(FileName, AttrFile, InfoFile);
  if ErrorReturn <> 0 Then Result := -1 else Result := InfoFile.Size;
 FindClose(InfoFile);
end;

function MyExitWindows(RebootParam: word): Boolean;
var
 TTokenHd: THandle;
 TTokenPvg: TTokenPrivileges;
 cbtpPrevious: DWORD;
 rTTokenPvg: TTokenPrivileges;
 pcbtpPreviousRequired: DWORD;
 tpResult: Boolean;
const
 SE_SHUTDOWN_NAME = 'SeShutdownPrivilege';
 Win32Platform: Integer = 0;
begin
 if Win32Platform = VER_PLATFORM_WIN32_NT then begin
  tpResult := OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES
   or TOKEN_QUERY, TTokenHd);
  if tpResult then begin
   tpResult := LookupPrivilegeValue(nil, SE_SHUTDOWN_NAME, TTokenPvg.Privileges[0].Luid);
   TTokenPvg.PrivilegeCount := 1;
   TTokenPvg.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
   cbtpPrevious := SizeOf(rTTokenPvg);
   pcbtpPreviousRequired := 0;
    if tpResult then
     Windows.AdjustTokenPrivileges(TTokenHd, False, TTokenPvg, cbtpPrevious,
      rTTokenPvg, pcbtpPreviousRequired);
    end;
  end;
 Result := ExitWindowsEx(RebootParam, 0);
end;

function UpperCase(const S: string): string;
var
  Ch: Char;
  L: Integer;
  Source, Dest: PChar;
begin
  L := Length(S);
  SetLength(Result, L);
  Source := Pointer(S);
  Dest := Pointer(Result);
  while L <> 0 do
  begin
    Ch := Source^;
    if (Ch >= 'a') and (Ch <= 'z') then Dec(Ch, 32);
    Dest^ := Ch;
    Inc(Source);
    Inc(Dest);
    Dec(L);
  end;
end;

function GetDirectorySize(ADirectory: string): Integer;
var
 Dir:  TSearchRec;
 Ret:  integer;
begin
 Result := 0;
 if ADirectory[length(ADirectory)] <> '\' then
   ADirectory := ADirectory + '\';

 Ret := FindFirst(ADirectory + '*.*', faAnyFile, Dir);
 while Ret = 0 do
  begin
     if Dir.Name[1] <> '.' then
       if Dir.Attr and faDirectory = faDirectory then
         inc(Result,GetDirectorySize(ADirectory + Dir.Name + '\'))
       else inc(Result,Dir.Size);
     Ret := FindNext(Dir);
  end;
 FindClose(Dir);
end;

function _GetDirectorySize;
var Size:integer;

 procedure _GetDirSize(ADirectory: string);
 var
  Dir:  TSearchRec;
  Ret:  integer;
 begin
  if Size > MaxSize then exit;

  Ret := FindFirst(ADirectory + '*.*', faAnyFile, Dir);
  while Ret = 0 do
   begin
     if Dir.Name[1] <> '.' then
       if Dir.Attr and faDirectory = faDirectory then
         _GetDirSize(ADirectory + Dir.Name + '\')
       else
        if Size > MaxSize then exit else inc(Size,Dir.Size);
     Ret := FindNext(Dir);
   end;
  FindClose(Dir);
 end;
begin
  Size := 0;
  if ADirectory[length(ADirectory)] <> '\' then
   ADirectory := ADirectory + '\';
  _GetDirSize(ADirectory);
  Result := Size > MaxSize;
  MaxSize :=  Size;
end;

function FileGetAttr(const FileName: string): Integer;
begin
  Result := GetFileAttributes(PChar(FileName));
end;

function FileSetAttr(const FileName: string; Attr: Integer): Integer;
begin
 Result := 0;
 if not SetFileAttributes(PChar(FileName), Attr) then Result := GetLastError;
end;

procedure DoDelTree(TheDir : String);
var
 Search : TSearchRec;
 rec    : word;
begin
 if TheDir[Length(TheDir)] <> '\' then TheDir := TheDir + '\';
  rec := FindFirst(TheDir + '*.*', faAnyFile, Search);
   while rec = 0 do begin
    if Search.Name[1] <> '.' then begin
     if (Search.Attr and faDirectory) = faDirectory then begin
      DoDelTree(TheDir + Search.Name);
      RmDir(TheDir + Search.Name);
     end else begin
      FileSetAttr(TheDir + Search.Name, 0);
      DeleteFile(PChar(TheDir + Search.Name));
      ProcessMessages;
     end;
    end;
   rec := FindNext(Search);
  end;
 FindClose(Search);
end;

function CreateUrl(Url, Path, Name: string): Boolean;
begin
 if UpperCase(Name) <> '.URL' then
  begin
   Name := Name+'.Url';
   if (Path <> '') and (Path[Length(Path)] <> '\') then Path := Path + '\';
   Result := WritePrivateProfileString('InternetShortcut', 'URL',
    PChar(Url), PChar(Path + Name));
  end else Result := False;
end;

procedure SysDelay(aMs: cardinal);
var
 TickCount: LongInt;
begin
 TickCount:=GetTickCount;
 while GetTickCount - TickCount < aMs do ProcessMessages;
end;

function RegisterServer(const aDllFileName: string; aRegister: Boolean): Boolean;
type
 TRegProc = function: HResult; stdcall;
const
 cRegFuncNameArr: array [Boolean] of PChar = ('DllUnregisterServer', 'DllRegisterServer');
var
 vLibHandle: THandle;
 vRegProc: TRegProc;
begin
 Result := False;
 vLibHandle := LoadLibrary(PChar(aDllFileName));
 if vLibHandle = 0 then Exit;
  @vRegProc := GetProcAddress(vLibHandle, cRegFuncNameArr[aRegister]);
 if @vRegProc <> nil then Result := vRegProc = S_OK;
  FreeLibrary(vLibHandle);
end;

end.
